#include <click/config.h>
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/glue.hh>
#include <clicknet/ip.h>
#include "aatable.hh"
#include "antarp.hh"
#include <clicknet/udp.h>
#include <click/packet_anno.hh>
#include <click/straccum.hh>
#include <click/ipaddress.hh>



CLICK_DECLS

AntARP::AntARP() : Element(1, 1) , _aaTable (0)
{}

AntARP::~ AntARP()
{}
int AntARP ::configure(Vector<String> &conf, ErrorHandler *errh)
{
  int res = cp_va_parse(conf, this, errh,  cpElement, "AntARPTable element" ,&_aaTable, cpEnd);
  return res;
}

void AntARP::updateAAtable(Packet *p)
{
  in_addr interface=IPAddress();
  in_addr lsAdr=IPAddress();
  const uint8_t *oa = p->network_header();
  int hlen = p->network_header_length();
  int oi = sizeof(click_ip);// lengde på Ipheader før options
  int xlen = oa[oi + 1];
  int last_ptr=oa[oi+2];
  int interface_nr=(PAINT_ANNO(p));

  if (last_ptr>8)
  {
    memcpy(&lsAdr , oa +oi + last_ptr-9, 4);// henter remote IPadresse som ligger i lsr
  }
  else
  {
    lsAdr = IPAddress(p->ip_header()->ip_src); // hvis siste lsr er foretatt(ptr=8) er srcadressen  remote
  }

  int gw=_aaTable->getGW(lsAdr);
  if(gw>-1)
  {
    if(gw=!interface_nr)
    {
      _aaTable->setIP(gw, IPAddress());
      // legger inn  lsAdr  i GW
      _aaTable->setIP(interface_nr, lsAdr);
    }
  }
  else
  {
    // legger inn lsAdr  i GW
    _aaTable->setIP(interface_nr, lsAdr);
  }
}

void
AntARP::notify_noutputs(int n)
{
  set_noutputs(n < 2 ? 1 : n);
}

void
AntARP::push(int, Packet *p)

{
  const IPAddress dest_adr = IPAddress(p->ip_header()->ip_dst);
  const IPAddress src_adr = IPAddress(p->ip_header()->ip_src);
  int test=_aaTable->isThisLocal(src_adr);
  int GW =_aaTable->getGW(dest_adr);
  if (test==0)
  {
    updateAAtable(p);
  }





  if(GW>=0)
  {
    output(GW).push(p);
  }
}
CLICK_ENDDECLS
ELEMENT_REQUIRES(AntARPTable)
EXPORT_ELEMENT(AntARP)
