#ifndef _ANTTRAFFICMONITOR_HH_
#define _ANTTRAFFICMONITOR_HH_
#include <click/element.hh>
#include <click/ewma.hh>
CLICK_DECLS

class AntTable;

class AntTrafficMonitor : public Element {
public:
  AntTrafficMonitor();
  ~AntTrafficMonitor();
  
  const char *class_name() const  { return "AntTrafficMonitor"; }
  const char *processing() const  { return AGNOSTIC; }
  void add_handlers();
  int configure(Vector<String> &, ErrorHandler *);
  int initialize(ErrorHandler *);

  Packet *simple_action(Packet *);

private:
  RateEWMA _packet_rate, _byte_rate;
  static String read_handler(Element *, void *);
  AntTable *_antTable;
  unsigned _if_no;
  double _beta;
  unsigned _now;
  int _x;
  int _delta;
};

CLICK_ENDDECLS
#endif //_ANTTRAFFICMONITOR_HH_
