#ifndef BACKWARDANT_HH
#define BACKWARDANT_HH
#include <click/element.hh>
CLICK_DECLS

class AntTable;

class BackwardAnt : public Element {
public:
  BackwardAnt();
  ~BackwardAnt();
  
  const char *class_name() const	{ return "BackwardAnt"; }
  const char *processing() const	{ return AGNOSTIC; }
  void add_handlers();
  int configure(Vector<String> &, ErrorHandler *);
  int initialize(ErrorHandler *);

  Packet *simple_action(Packet *);

private:
  uint32_t _state;
  static String read_handler(Element *, void *);
  String routingTable();

  void readTempAndCost(Packet *p, int *explore, double *tmpE, double *cost, double *temperature, double *beta);
  in_addr getDestination(Packet *p);
  AntTable *_antTable;
};

CLICK_ENDDECLS
#endif
