#ifndef UPDATEPATHTABLE_HH
#define UPDATEPATHTABLE_HH
//#include <click/ipaddresslist.hh>
#include <click/element.hh>
#include <click/atomic.hh>

#include <click/handlercall.hh>
CLICK_DECLS

class AntARPTable;

class UpdatePathTable : public Element
{
public:

  UpdatePathTable();
  ~UpdatePathTable();
  const char *class_name() const { return "UpdatePathTable"; }
  const char *processing() const { return PUSH; }
  int configure(Vector<String>&, ErrorHandler*);
  void push(int, Packet *);
  void notify_noutputs(int);
  uint32_t maxSize;
  in_addr tmpSrc;



private:
  Vector<int>costVector;
  AntARPTable *_aaTable;
  void addCostVectorValue(int);
  void clearVector();
  int getCostVectorSize();
  int getCostVectorValue(int);
  // extract the parameters from the payload
  void getPayload(Packet *p,  int *explore, double *rho, double *beta, int *totCost);
  // calculate the diffrent values
  void calculatePayload(Packet *p, double *X, double *gamma, double *beta, double *rho, double *tmpNAMtime, int *eliteant, int *totCost);
  //Make the new packet return to source;
  Packet * generateUpdateAnt(Packet *p, int *_flag, double *X, int *totCost, double *gamma, double *beta);
  Packet *handle_options(Packet *);
  Packet * update_checksum2(WritablePacket *p);
  Packet * addPayload(Packet *p, String payload);
  int kostaddteller;
  int antallfeilGP;
  int antallfeilCP;
  int antallfeilGUA;
  int feil;
  int out;
  double beta;
  double rho;



};
CLICK_ENDDECLS
#endif
