#!/bin/sh

MAC=$(/usr/sbin/nvram get et0macaddr)
NAME=$(/usr/sbin/nvram get wan_hostname)
WAN_IPADDR=$(/usr/sbin/nvram get wan_ipaddr)

echo " Change network configuration for $NAME"

echo "remove vlan"
vconfig rem vlan0
vconfig rem vlan1
vconfig rem vlan3
vconfig rem vlan4
vconfig rem vlan5
vconfig rem vlan6

echo "reconfigure"
robocfg switch disable
robocfg vlans enable reset
if [ $NAME -eq AR-10 ]; then
	robocfg vlan 1 ports "0 5t" port 0 state enabled stp none
	robocfg vlan 3 ports "1 5t"
	robocfg vlan 4 ports "2 5t"
	robocfg vlan 5 ports "3 5t"
	robocfg vlan 6 ports "4 5t"
else
	robocfg vlan 1 ports "4 5t" port 0 state enabled stp none
	robocfg vlan 3 ports "3 5t"
	robocfg vlan 4 ports "2 5t"
	robocfg vlan 5 ports "1 5t"
	robocfg vlan 6 ports "0 5t"
fi
robocfg switch enable
echo "switch reconfigured"

vconfig add eth0 1
vconfig add eth0 3
vconfig add eth0 4
vconfig add eth0 5
vconfig add eth0 6
echo "vconfig done ok"

ifconfig vlan1 hw ether $MAC
ifconfig vlan1 $WAN_IPADDR netmask 255.255.255.0

case $NAME in
	AR-1 )
		echo "Configure mac addr and ip-addr for router $NAME"
		ifconfig vlan3 hw ether 00:0A:0A:01:05:01
		ifconfig vlan4 hw ether 00:0A:0A:01:02:01
		ifconfig vlan5 hw ether 00:0A:0A:01:03:01
		ifconfig vlan6 hw ether 00:0A:0A:01:09:01
		
		ifconfig vlan3 10.1.129.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.129.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.129.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.129.4 netmask 255.255.255.0
		;;

	AR-2 )
		ifconfig vlan3 hw ether 00:0A:0A:02:06:01
		ifconfig vlan4 hw ether 00:0A:0A:02:04:01
		ifconfig vlan5 hw ether 00:0A:0A:01:02:02
		ifconfig vlan6 hw ether 00:0A:0A:02:10:01
		
		ifconfig vlan3 10.1.130.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.130.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.130.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.130.4 netmask 255.255.255.0
		;;

	AR-3 )
		ifconfig vlan3 hw ether 00:0A:0A:03:07:01
		ifconfig vlan4 hw ether 00:0A:0A:03:04:01
		ifconfig vlan5 hw ether 00:0A:0A:01:03:02
		ifconfig vlan6 hw ether 00:0A:0A:03:11:01
		
		ifconfig vlan3 10.1.131.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.131.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.131.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.131.4 netmask 255.255.255.0
		;;

	AR-4 )
		ifconfig vlan3 hw ether 00:0A:0A:04:08:03
		ifconfig vlan4 hw ether 00:0A:0A:04:08:01
		ifconfig vlan5 hw ether 00:0A:0A:03:04:02
		ifconfig vlan6 hw ether 00:0A:0A:02:04:02
		
		ifconfig vlan3 10.1.132.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.132.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.132.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.132.4 netmask 255.255.255.0
		;;

	AR-5 )
		ifconfig vlan3 hw ether 00:0A:0A:05:06:01
		ifconfig vlan4 hw ether 00:0A:0A:05:06:03
		ifconfig vlan5 hw ether 00:0A:0A:02:06:02
		ifconfig vlan6 hw ether 00:0A:0A:05:06:04
		
		ifconfig vlan3 10.1.133.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.133.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.133.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.133.4 netmask 255.255.255.0
		;;

	AR-6 )
		ifconfig vlan3 hw ether 00:0A:0A:06:10:01
		ifconfig vlan4 hw ether 00:0A:0A:06:08:01
		ifconfig vlan5 hw ether 00:0A:0A:02:06:02
		ifconfig vlan6 hw ether 00:0A:0A:05:06:02
		
		ifconfig vlan3 10.1.134.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.134.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.134.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.134.4 netmask 255.255.255.0
		;;

	AR-7 )
		ifconfig vlan3 hw ether 00:0A:0A:07:08:01
		ifconfig vlan4 hw ether 00:0A:0A:07:08:03
		ifconfig vlan5 hw ether 00:0A:0A:03:07:02
		ifconfig vlan6 hw ether 00:0A:0A:07:08:04
		
		ifconfig vlan3 10.1.135.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.135.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.135.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.135.4 netmask 255.255.255.0
		;;

	AR-8 )
		ifconfig vlan3 hw ether 00:0A:0A:06:08:02
		ifconfig vlan4 hw ether 00:0A:0A:04:08:02
		ifconfig vlan5 hw ether 00:0A:0A:08:11:01
		ifconfig vlan6 hw ether 00:0A:0A:07:08:02
		
		ifconfig vlan3 10.1.136.1 netmask 255.255.255.0
		ifconfig vlan4 10.1.136.2 netmask 255.255.255.0
		ifconfig vlan5 10.1.136.3 netmask 255.255.255.0
		ifconfig vlan6 10.1.136.4 netmask 255.255.255.0
		;;

	AR-9 )
		ifconfig vlan3 hw ether 00:0A:0A:09:10:01
		ifconfig vlan4 hw ether 00:0A:0A:09:10:03
		ifconfig vlan5 hw ether 00:0A:0A:01:09:02
		ifconfig vlan6 hw ether 00:0A:0A:09:10:04
		
		#ifconfig vlan3 192.168.9.1 netmask 255.255.255.0
		#ifconfig vlan4 192.168.9.2 netmask 255.255.255.0
		#ifconfig vlan5 192.168.9.3 netmask 255.255.255.0
		#ifconfig vlan6 192.168.9.4 netmask 255.255.255.0
		;;

	AR-10 )
		echo "Config AR10"
		ifconfig vlan3 hw ether 00:0A:0A:06:10:02
		ifconfig vlan4 hw ether 00:0A:0A:10:11:01
		ifconfig vlan5 hw ether 00:0A:0A:02:10:02
		ifconfig vlan6 hw ether 00:0A:0A:09:10:02
		
		#ifconfig vlan3 192.168.10.1 netmask 255.255.255.0
		#ifconfig vlan4 192.168.10.2 netmask 255.255.255.0
		#ifconfig vlan5 192.168.10.3 netmask 255.255.255.0
		#ifconfig vlan6 192.168.10.4 netmask 255.255.255.0
		echo "Done with AR10"
		;;
esac
		
echo "ifconfig ip done"

ifconfig vlan1 up
ifconfig vlan3 up
ifconfig vlan4 up
ifconfig vlan5 up
ifconfig vlan6 up
echo "ifconfig done"

ifconfig > /etc/ifconfig.out
robocfg show > /etc/robocfg.show

echo "Done"
