// Auto-generated by make-ant-router.pl
// vlan3 10.1.8.1 00:0A:0A:06:08:02
// vlan4 10.1.8.2 00:0A:0A:04:08:02
// vlan5 10.1.8.3 00:0A:0A:08:11:01
// vlan6 10.1.8.4 00:0A:0A:07:08:02

AddressInfo (
	 vlan3 10.1.8.1,
	 vlan4 10.1.8.2,
	 vlan5 10.1.8.3,
	 vlan6 10.1.8.4);

AlignmentInfo(
	c0 4 2,
	c1 4 2,
	c2 4 2,
	c3 4 2);

at :: AntTable(
	vlan3/255.255.255.0 3 35,
	vlan4/255.255.255.0 2 30,
	vlan5/255.255.255.0 1 1,
	vlan6/255.255.255.0 0 1);
// {}

elementclass prepareIP1 {$no, $ip |
	/* Remove ethernet header, update source routing .. */
	//input -> Paint($no) -> Strip(14) -> MarkIPHeader() -> SourceRoute($ip) -> output;
	input -> Paint($no) -> Strip(14) -> MarkIPHeader() -> output;
};

elementclass prepareIP2 {$no, $ip |
	/* Drops link-level broadcast and multicast packets, update route record, time-to-live etc. */
	input -> DropBroadcasts
		-> cp0 :: PaintTee($no)
		-> gio0 :: IPGWOptions($ip)
		-> FixIPSrc($ip)
		-> dt0 :: DecIPTTL
		-> fr0 :: IPFragmenter(1500)
		-> atm :: AntTrafficMonitor(at, $no, 0.85)
		-> output;
	dt0[1] -> ICMPError($ip, timeexceeded) -> [1] output;
	fr0[1] -> ICMPError($ip, unreachable, needfrag) -> [1] output;
	gio0[1] -> ICMPError($ip, parameterproblem) -> [1] output;
	cp0[1] -> ICMPError($ip, redirect, host) -> [1] output;
};

aat :: AntARPTable(vlan3, vlan4, vlan5, vlan6);
rt :: AntARP(aat);
ut::UpdateAATbl(aat);
utpath::UpdatePathTable(aat);	

sr :: SourceRoute(0.0.0.0) -> rt;	

ip :: CheckIPHeader(VERBOSE true, DETAILS true)-> DropBroadcasts
    -> ant :: IPClassifier(dst udp port 51234, src udp port 51234, -);

ant[0] -> ut;
ant[1] -> BackwardAnt(at) -> sr;
ant[2] -> sr;
ut[0]  -> fa :: ForwardAnt(at);
ut[1]  -> rt;

// ARP responses are copied to each ARPQuerier and the host.
arpt :: Tee(5);

// Input and output paths for vlan3
c0 :: Classifier(12/0806 20/0001, 12/0806 20/0002, 12/0800, -);
FromDevice(vlan3) -> c0;
out0 :: Queue(200) -> todevice0 :: ToDevice(vlan3);
//FromDevice(vlan3) -> ToDump("/bison/openwrt/logs/from_10.1.8.1") -> c0;
//out0 :: Queue(200) -> ToDump("/bison/openwrt/logs/to_10.1.8.1") -> todevice0 :: ToDevice(vlan3);
arpq0 :: ARPQuerier(10.1.8.1, 00:0A:0A:06:08:02) -> out0;
c0[0] -> ar0 :: ARPResponder(10.1.0.0/18 00:0A:0A:06:08:02) -> out0;
c0[1] -> arpt;
c0[2] -> prepareIP1(0, vlan3) -> ip;
c0[3] -> Discard;
arpt[0] -> [1]arpq0;

// Input and output paths for vlan4
c1 :: Classifier(12/0806 20/0001, 12/0806 20/0002, 12/0800, -);
FromDevice(vlan4) -> c1;
out1 :: Queue(200) -> todevice1 :: ToDevice(vlan4);
//FromDevice(vlan4) -> ToDump("/bison/openwrt/logs/from_10.1.8.2") -> c1;
//out1 :: Queue(200) -> ToDump("/bison/openwrt/logs/to_10.1.8.2") -> todevice1 :: ToDevice(vlan4);
arpq1 :: ARPQuerier(10.1.8.2, 00:0A:0A:04:08:02) -> out1;
c1[0] -> ar1 :: ARPResponder(10.1.0.0/18 00:0A:0A:04:08:02) -> out1;
c1[1] -> arpt;
c1[2] -> prepareIP1(1, vlan4) -> ip;
c1[3] -> Discard;
arpt[1] -> [1]arpq1;

// Input and output paths for vlan5
c2 :: Classifier(12/0806 20/0001, 12/0806 20/0002, 12/0800, -);
FromDevice(vlan5) -> c2;
out2 :: Queue(200) -> todevice2 :: ToDevice(vlan5);
//FromDevice(vlan5) -> ToDump("/bison/openwrt/logs/from_10.1.8.3") -> c2;
//out2 :: Queue(200) -> ToDump("/bison/openwrt/logs/to_10.1.8.3") -> todevice2 :: ToDevice(vlan5);
arpq2 :: ARPQuerier(10.1.8.3, 00:0A:0A:08:11:01) -> out2;
c2[0] -> ar2 :: ARPResponder(10.1.0.0/18 00:0A:0A:08:11:01) -> out2;
c2[1] -> arpt;
c2[2] -> prepareIP1(2, vlan5) -> ip;
c2[3] -> Discard;
arpt[2] -> [1]arpq2;

// Input and output paths for vlan6
c3 :: Classifier(12/0806 20/0001, 12/0806 20/0002, 12/0800, -);
FromDevice(vlan6) -> c3;
out3 :: Queue(200) -> todevice3 :: ToDevice(vlan6);
//FromDevice(vlan6) -> ToDump("/bison/openwrt/logs/from_10.1.8.4") -> c3;
//out3 :: Queue(200) -> ToDump("/bison/openwrt/logs/to_10.1.8.4") -> todevice3 :: ToDevice(vlan6);
arpq3 :: ARPQuerier(10.1.8.4, 00:0A:0A:07:08:02) -> out3;
c3[0] -> ar3 :: ARPResponder(10.1.0.0/18 00:0A:0A:07:08:02) -> out3;
c3[1] -> arpt;
c3[2] -> prepareIP1(3, vlan6) -> ip;
c3[3] -> Discard;
arpt[3] -> [1]arpq3;

// Local delivery
toh :: Discard;
arpt[4] -> toh;
rt[4] -> local :: IPReassembler -> ping_ipc :: IPClassifier(icmp type echo, -);
ping_ipc[0] -> ICMPPingResponder -> [0]rt;
ping_ipc[1] -> EtherEncap(0x0800, 1:1:1:1:1:1, 2:2:2:2:2:2) -> toh;

// Forwarding path for vlan3
rt[0] -> pvlan3 :: prepareIP2(0, vlan3);
pvlan3[0] -> [0]arpq0;
pvlan3[1] -> rt;

// Forwarding path for vlan4
rt[1] -> pvlan4 :: prepareIP2(1, vlan4);
pvlan4[0] -> [0]arpq1;
pvlan4[1] -> rt;

// Forwarding path for vlan5
rt[2] -> pvlan5 :: prepareIP2(2, vlan5);
pvlan5[0] -> [0]arpq2;
pvlan5[1] -> rt;

// Forwarding path for vlan6
rt[3] -> pvlan6 :: prepareIP2(3, vlan6);
pvlan6[0] -> [0]arpq3;
pvlan6[1] -> rt;

// Routing from ForwardAnt
fa[0] -> pvlan3;
fa[1] -> pvlan4;
fa[2] -> pvlan5;
fa[3] -> pvlan6;
fa[4] -> utpath;  // Packet is for this host
fa[5] -> rt;
utpath [0] -> rt;
utpath [1] -> sr;
